<template>
  <v-container>
    <v-dialog v-model="showDialog" max-width="70vw" persistent>
      <v-card v-if="processType === 'edit'">
        <v-card-title>Edit {{ item?.email }} </v-card-title>
        <v-divider></v-divider>
        <v-container>
          <v-row no-gutters align="center">
            <v-layout column class="mt-2 mx-3">
              <v-col cols="10">
                <span>Current Nodes:</span>
                <v-chip-group column>
                  <v-chip
                    small
                    v-for="(node, index) in initialNodes"
                    :key="index"
                  >
                    <v-icon left v-if="node.level == 'portaladmin'">
                      mdi-alpha-p-box-outline
                    </v-icon>
                    <UILogo
                      v-if="Object.keys(node).includes('tenant_id')"
                      v-bind:tenant="node.name"
                      class="mr-1"
                    />
                    {{ node.name }}</v-chip
                  >
                </v-chip-group>
                <div>
                  <span>New Nodes:</span>
                  <v-chip-group column>
                    <v-chip
                      small
                      close
                      v-for="(node, index) in selectedNodes"
                      :key="index"
                      @click:close="removeNode(node)"
                    >
                      <v-icon left v-if="node.level == 'portaladmin'">
                        mdi-alpha-p-box-outline
                      </v-icon>
                      <UILogo
                        v-if="Object.keys(node).includes('tenant_id')"
                        v-bind:tenant="node.name"
                        class="mr-1"
                      />
                      {{ node.name }}</v-chip
                    >
                  </v-chip-group>
                </div>
              </v-col>
              <v-col
                cols="12"
                class="py-0 text-end"
                v-if="$store.getters['user/isPortalAdmin']"
              >
                <v-btn
                  text
                  small
                  color="blue darken-1"
                  @click="addPortalRole"
                  :disabled="disablePortalPromotion"
                  >Promote to Portal-Admin</v-btn
                >
              </v-col>
              <v-col cols="8" v-if="!$store.getters['user/isOrgaAdmin']">
                <v-select
                  dense
                  return-object
                  required
                  label="Tenants"
                  :items="tenants"
                  item-text="name"
                  item-value="tenant_id"
                  hint="Assign tenant(s) to the user"
                  persistent-hint
                  v-model="selectedTenants"
                  @change="tenantsChanged"
                  clearable
                ></v-select>
              </v-col>
              <v-col cols="8">
                <v-autocomplete
                  dense
                  :search-input.sync="search"
                  :loading="isOrgLoading"
                  :items="organisations"
                  return-object
                  required
                  prepend-icon="mdi-database-search"
                  label="Type to search for organisation"
                  item-text="name"
                  item-value="organisation_id"
                  hint="Assign organisation(s) to the user"
                  persistent-hint
                  v-model="selectedOrgas"
                  @change="orgasChanged"
                  clearable
                ></v-autocomplete>
              </v-col>
            </v-layout>
          </v-row>
        </v-container>
        <v-divider></v-divider>
        <v-card-actions>
          <v-text-field v-if="loading" loading disabled></v-text-field>
          <UIAlert
            v-if="!loading && (hasRequestError || hasOrgaLoadingError)"
            v-bind:isSuccessful="false"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <div
            v-if="
              !hasRequestError &&
                !loading &&
                (removedPortalRole ||
                  addedPortalRole ||
                  addedTenantRole ||
                  removedTenantRole)
            "
            class="d-flex align-center pa-1 warning--text"
            style="width: 100%;"
          >
            <span style="white-space: pre-line;">
              {{ generateNotificationMsg() }}
            </span>
            <div class="ml-auto">
              <v-btn text color="blue darken-1" @click="resetChanges()"
                >cancel</v-btn
              >
              <v-btn
                text
                color="blue darken-1"
                @click="
                  addedTenantRole = false;
                  removedTenantRole = false;
                  addedPortalRole = false;
                  removedPortalRole = false;
                  updateUser();
                "
                >Confirm</v-btn
              >
            </div>
          </div>
          <div class="ml-auto" v-else>
            <v-btn
              color="blue darken-1"
              text
              @click="
                $emit('child-object', {
                  closeDialog: true,
                  userChanged: false
                })
              "
            >
              Cancel
            </v-btn>
            <v-btn color="blue darken-1" text @click="checkUserForUpdate()">
              save
            </v-btn>
          </div>
        </v-card-actions>
      </v-card>
      <v-card v-else-if="processType === 'delete'">
        <v-card-title class="headline">
          Are you sure you want to delete
          {{ item ? item.name : "" }} ?
        </v-card-title>
        <v-divider></v-divider>
        <v-card-actions>
          <v-text-field v-if="loading" loading disabled></v-text-field>
          <UIAlert
            class="mt-4"
            v-if="hasRequestError && !loading"
            v-bind:isSuccessful="!hasRequestError"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', {
                closeDialog: true,
                userChanged: false
              })
            "
            >close</v-btn
          >
          <v-btn color="blue darken-1" text @click="confirmDeletion">yes</v-btn>
        </v-card-actions>
      </v-card>
      <v-card v-else>
        <v-card-title>Add User</v-card-title>
        <v-divider></v-divider>
        <v-container>
          <v-row justify="center" align="center">
            <v-col cols="11">
              <v-form v-model="valid" class="pa-2" ref="form">
                <v-text-field
                  style="width:50%;"
                  v-model="email"
                  :rules="emailRules"
                  label="Invite an Admin by email"
                  required
                ></v-text-field>
                <v-row class="text-body-1">
                  <v-col cols="12">
                    <v-select
                      v-if="$store.getters['user/isPortalAdmin']"
                      dense
                      return-object
                      required
                      style="max-Width:50%"
                      label="Tenants"
                      :items="tenants"
                      item-text="name"
                      item-value="tenant_id"
                      hint="Add admin for a tenant"
                      persistent-hint
                      v-model="selectedTenant"
                      @change="tenantSelected"
                      clearable
                    ></v-select>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                      style="width:50%;"
                      v-if="
                        totalOrganisations > 10 || (search && search !== '')
                      "
                      label="Search For an Organisation"
                      labdl="Add admin for an organisation"
                      hide-details
                      persistent-hint
                      v-model="search"
                      clearable
                      append-icon="mdi-magnify"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-data-table
                      class="mt-2"
                      style="cursor: pointer"
                      dense
                      v-if="totalOrganisations <= 10 || search"
                      hide-default-footer
                      :headers="[
                        {
                          text: 'Organisation',
                          align: 'start',
                          value: 'name',
                          divider: 'true',
                          width: '25%'
                        },
                        {
                          text: 'Constituency',
                          value: 'tenants',
                          divider: true,
                          width: '25%',
                          sortable: false
                        },
                        {
                          text: 'Parent Nodes',
                          value: 'parents',
                          sortable: false
                        }
                      ]"
                      :items="organisations"
                      :items-per-page="10"
                      @click:row="rowClicked"
                      item-key="organisation_id"
                      single-select
                      :loading="isOrgLoading && !hasOrgaLoadingError"
                      :no-data-text="
                        hasOrgaLoadingError
                          ? 'Loading Error'
                          : 'No data available'
                      "
                    >
                      <template v-slot:[`item.tenants`]="{ item }">
                        <div class="d-flex">
                          <UILogo
                            class="mx-1"
                            v-for="(tenant, i) in item.tenants"
                            :key="i"
                            v-bind:tenant="tenant.name"
                          />
                        </div>
                      </template>
                    </v-data-table>
                  </v-col>
                </v-row>
                <div v-if="!selectedOrga" class="error--text text-body-2 my-2">
                  Please select
                  {{
                    $store.getters["user/isPortalAdmin"]
                      ? "tenant/organisation"
                      : "an organisation"
                  }}
                </div>
              </v-form>
            </v-col>
          </v-row>
        </v-container>
        <v-divider></v-divider>
        <v-card-actions>
          <v-text-field v-if="loading" loading disabled></v-text-field>
          <UIAlert
            v-if="!loading && (hasRequestError || hasOrgaLoadingError)"
            v-bind:isSuccessful="false"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', {
                closeDialog: true,
                userChanged: false
              })
            "
          >
            close
          </v-btn>
          <v-btn
            text
            color="blue darken-1"
            :disabled="!valid || !selectedOrga"
            @click="inviteUser"
          >
            Invite
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>
<style lang="scss" scoped>
::v-deep tr.v-data-table__selected td {
  background: #e0e0e0;
}
::v-deep tr.v-data-table__selected td:first-child::after {
  content: "  \2714";
  color: rgb(0, 119, 0);
  font-size: 1.5rem;
}
</style>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { useForm } from "@/lib/use-form";
import { useNotification } from "@/lib/use-notification";
import { useOrganisation } from "@/lib/use-organisation";
import { useStore } from "@/store";
import debounce from "debounce";

import { computed, defineAsyncComponent, onMounted, ref, watch } from "vue";
import { HTTP } from "@/lib/http";

const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const UILogo = defineAsyncComponent(() => import("@/components/ui/UILogo.vue"));
const props = defineProps({
  item: Object,
  processType: String
});
const emit = defineEmits(["child-object"]);

const showDialog = true;
const store = useStore();
const { hasRequestError } = useNotification();
const { form, email, emailRules, valid } = useForm();
// Update User
const loading = ref(false);
const updateUser = () => {
  loading.value = true;
  const payload = {};
  const tenantIds: number[] = [];
  const orgaIds: number[] = [];
  type Groups = "portaladmin" | "tenantadmin" | "orgaadmin";
  const groups: Groups[] = [];

  selectedNodes.value.forEach(n => {
    if (n.organisation_id) {
      if (!groups.includes("orgaadmin")) {
        groups.push("orgaadmin");
      }
      orgaIds.push(n.organisation_id);
    }
    if (n.tenant_id) {
      if (!groups.includes("tenantadmin")) {
        groups.push("tenantadmin");
      }
      tenantIds.push(n.tenant_id);
    }
    if (n.level && n.level === "portaladmin") {
      if (!groups.includes("portaladmin")) {
        groups.push("portaladmin");
      }
    }
  });
  payload["groups"] = groups;
  payload["tenants"] = tenantIds;
  payload["organisations"] = orgaIds;
  HTTP.put("/users/" + props.item?.id, payload)
    .then(() => {
      loading.value = false;
      emit("child-object", {
        closeDialog: true,
        userChanged: true
      });
    })
    .catch(() => {
      loading.value = false;
      hasRequestError.value = true;
    });
};
// Tenants
const selectedTenants = ref();
const tenants = computed(() => {
  return store.getters["user/getUserTenants"];
});
// Organisations
const {
  organisations,
  hasOrgaLoadingError,
  isOrgLoading,
  totalOrganisations,
  getOrganisations
} = useOrganisation();
const selectedOrgas = ref();
onMounted(() => {
  if (props.processType !== "delete") {
    const promisesArray: Promise<void>[] = [];
    if (!store.getters["user/isOrgaAdmin"]) {
      promisesArray.push(store.dispatch("application/getTenants"));
    }
    promisesArray.push(getOrganisations(1));
    Promise.all(promisesArray).then(() => {
      if (props.processType === "edit") {
        extractNodes();
      }
    });
    if (props.processType === "add") {
      form.value.validate();
    }
  }
});

const disablePortalPromotion = computed(() => {
  if (selectedNodes.value && selectedNodes.value.length) {
    return selectedNodes.value.some(n => n.level === "portaladmin");
  }
  return false;
});
const addPortalRole = () => {
  selectedNodes.value.push({ level: "portaladmin" });
};
interface Node {
  level: string;
  name?: string;
  tenant_id?: number;
  organisation_id?: number;
}
const selectedNodes = ref<Node[]>([]);
const initialOrgas = ref();
const initialTenants = ref();
const initialNodes = ref();
// Extract the initial nodes of the user
const extractNodes = () => {
  initialNodes.value = [];
  initialOrgas.value = [];
  initialTenants.value = [];
  props.item?.groups.forEach(g => {
    if (g.level === "portaladmin") {
      initialNodes.value.push(g);
    }
    if (g.level === "tenantadmin") {
      initialTenants.value = g.nodes.filter(n => n);
      initialTenants.value.forEach(t => (t.tenant_id = t.node_id));
    }
    if (g.level === "orgaadmin") {
      initialOrgas.value = g.nodes.filter(n => n);
      initialOrgas.value.forEach(t => (t.organisation_id = t.node_id));
    }
  });
  initialNodes.value = initialNodes.value.concat(
    initialTenants.value,
    initialOrgas.value
  );
  // Modifyied nodes and initial nodes are same by the first load
  selectedNodes.value = initialNodes.value.filter(r => r);
};
// Check if an extra confirmation is needed
const checkUserForUpdate = () => {
  let isPortal = false;
  let isTenant = false;
  if (initialNodes.value.some(t => t.level === "portaladmin")) {
    isPortal = true;
  }
  if (initialNodes.value.some(t => t.tenant_id)) {
    isTenant = true;
  }
  if (selectedNodes.value && selectedNodes.value.length) {
    if (!selectedNodes.value.some(n => n.tenant_id) && isTenant) {
      removedTenantRole.value = true;
    }
    if (selectedNodes.value.some(n => n.tenant_id) && !isTenant) {
      addedTenantRole.value = true;
    }
    if (!selectedNodes.value.some(n => n.level === "portaladmin") && isPortal) {
      removedPortalRole.value = true;
    }
    if (selectedNodes.value.some(n => n.level === "portaladmin") && !isPortal) {
      addedPortalRole.value = true;
    }
  }
  if (
    !addedPortalRole.value &&
    !addedTenantRole.value &&
    !removedPortalRole.value &&
    !removedTenantRole.value
  ) {
    updateUser();
  }
};
const resetChanges = () => {
  if (removedPortalRole.value) {
    addPortalRole();
    removedPortalRole.value = false;
  }
  if (addedPortalRole.value) {
    removeNode({ level: "portaladmin" });
    addedPortalRole.value = false;
  }
  if (removedTenantRole.value) {
    const tmpNode = initialNodes.value.filter(n => n.tenant_id)[0];
    tenantsChanged(tmpNode);
    removedTenantRole.value = false;
  }
  if (addedTenantRole.value) {
    const tmpNode = selectedNodes.value.filter(n => n.tenant_id);
    tmpNode.forEach(n => {
      removeNode(n);
    });
    addedTenantRole.value = false;
  }
};
const addedPortalRole = ref(false);
const removedPortalRole = ref(false);
const addedTenantRole = ref(false);
const removedTenantRole = ref(false);

const removeNode = item => {
  // As there are multiple objects in the "selectedNodes" Array
  // check every object type
  if (item.tenant_id) {
    selectedNodes.value = selectedNodes.value.filter(
      n => n.tenant_id !== item.tenant_id
    );
    // clear select-field
    selectedTenants.value = {};
  }
  if (item.organisation_id) {
    selectedNodes.value = selectedNodes.value.filter(
      n => n.organisation_id !== item.organisation_id
    );
    // clear select-field
    selectedOrgas.value = {};
  }
  if (item.level && item.level === "portaladmin") {
    selectedNodes.value = selectedNodes.value.filter(
      n => n.level !== "portaladmin"
    );
  }
};
// Add to the selected node only if the added item does not included
// in the "selectedNode" array
const tenantsChanged = item => {
  if (item) {
    if (!selectedNodes.value.some(t => t.tenant_id === item.tenant_id)) {
      selectedNodes.value.push(item);
    }
  }
};
const orgasChanged = item => {
  if (item) {
    if (
      !selectedNodes.value.some(t => t.organisation_id === item.organisation_id)
    ) {
      selectedNodes.value.push(item);
    }
  }
};
// Search
const search = ref(null);
const triggerSearch = debounce(searchString => {
  getOrganisations(1, undefined, searchString);
}, 500);

watch(
  // Make a request for each change in the search-field.
  () => search.value,
  (newValue, oldValue) => {
    if (oldValue !== newValue) {
      triggerSearch(newValue);
    }
  }
);
const generateNotificationMsg = () => {
  let addedMsg = "";
  if (addedPortalRole.value || addedTenantRole.value) {
    addedMsg += `${addedPortalRole.value ? " Portal-Role" : ""}${
      addedTenantRole.value ? " Tenant-Role" : ""
    }`;
  }
  let removedMsg = "";
  if (removedPortalRole.value || removedTenantRole.value) {
    removedMsg += `${removedPortalRole.value ? "Portal-Role" : ""}${
      removedTenantRole.value ? "Tenant-Role" : ""
    }`;
  }
  let fullMsg = "Please Confirm/Cancel the following change(s):\n";
  if (addedMsg) {
    fullMsg += "Add" + addedMsg + "\n";
  }
  if (removedMsg) {
    fullMsg += "Remove" + removedMsg;
  }
  return fullMsg;
};
const confirmDeletion = () => {
  loading.value = true;
  HTTP.delete("/users/" + props.item?.id)
    .then(() => {
      emit("child-object", { closeDialog: true, userChanged: true });
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};
// Add User
const selectedOrga = ref();
const selectedTenant = ref();
let lastClickedRow;
const rowClicked = (item, row) => {
  let isSameRow = false;
  if (lastClickedRow) {
    lastClickedRow.select(false);
    if (lastClickedRow.index === row.index) {
      selectedOrga.value = null;
      isSameRow = true;
    }
  }
  if (!isSameRow) {
    lastClickedRow = row;
    row.select(true);
    selectedOrga.value = item;
    selectedTenant.value = null;
  }
};
const tenantSelected = () => {
  selectedOrga.value = selectedTenant.value;
  if (lastClickedRow) {
    lastClickedRow.select(false);
  }
};
const inviteUser = () => {
  loading.value = true;
  let invitedAdmin;
  if ("tenant_id" in selectedOrga.value) {
    invitedAdmin = {
      group: "tenantadmin",
      nodeID: selectedOrga.value.tenant_id
    };
  } else {
    invitedAdmin = {
      group: "orgaadmin",
      nodeID: selectedOrga.value.organisation_id
    };
  }
  HTTP.post("/users", {
    email: email.value,
    group: invitedAdmin.group,
    node_id: invitedAdmin.nodeID
  })
    .then(() => {
      form.value.reset;
      emit("child-object", {
        closeDialog: true,
        userChanged: true
      });
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      loading.value = false;
    });
};
</script>
